<?PHP
session_start();

include_once('conf/config.php');
include_once('conf/dbconfig.php');
include_once('conf/version.php');
include_once('lib/utils.php');
include_once('lib/dbwrapper.php');

############################################################
function checkSteps(){
############################################################
    $checkstep	= (isset($_POST['checkstep']))	? $_POST['checkstep'] : 0;
    $nextStep = 1;

    switch($checkstep){
	case   1:	$nextStep = checkStartScreen();		break;
	case   2:	$nextStep = checkEditDatabase(3,0);	break;
	case   3:	$nextStep = checkInsAdminUser();	break;
	case 100:	$nextStep = checkEditDatabase(101,0);	break;
	case 101:	$nextStep = checkEditDatabase(102,1);	break;
	case 102:	$nextStep = checkDBConvert();		break;
	case 103:	$nextStep = checkInsAdminUser();	break;	    
    }
    return $nextStep;
}

############################################################
function installSteps(){
############################################################
    $step = checkSteps();
    switch($step){
	case 1:		dispStartScreen();					break;
	case 2:		dispEditDatabase(2,"Enter Database connection");	break;
	case 3:		dispInsAdminUser(3);					break;
	case 100:	dispEditDatabase(100,"Enter v1.1 Database connection");	break; 
	case 101:	dispEditDatabase(101,"Enter v1.0 Database connection");	break;
	case 102:	dispDBConvert();					break; 
	case 103:	dispInsAdminUser(103);					break;    
	case 999:	dispEndScreen();					break;    
    }
}

############################################################
function dispStartScreen(){
############################################################
    echo "<form name='install' method='post' action='install.php' accept-charset='UTF-8'>\n";
    echo "<input name='checkstep' value='1' type='hidden'>\n";
    echo " <table class ='tabbord3'>\n";
    echo "  <tr class='th_headC'>\n";
    echo "   <td colspan='2'>New Installation or Update Old Version<br>";
    HandleMSG();
    echo "	</td>\n";
    echo "  </tr><tr class='th_headC'>\n";
    echo "   <td><input class='button1' name='button' type='submit' value='New'></td>\n";
    echo "   <td><input class='button1' name='button' type='submit' value='Update'></td>\n";
    echo "  </tr>\n";
    echo " </table>\n";
    echo "</form>\n";
}
############################################################
function checkStartScreen(){
############################################################
    $button	= (isset($_POST['button']))	? $_POST['button'] : "";
    $nextStep = 1;
    if($button == "New") 	$nextStep = 2;
    if($button == "Update") 	$nextStep = 100;
    return $nextStep;
}

############################################################
function dispEditDatabase($chkstep, $title){
############################################################
    require "conf/dbconfig.php";
    echo "<form name='install' method='post' action='install.php' accept-charset='UTF-8'>\n";
    echo "<input name='checkstep' value='".$chkstep."' type='hidden'>\n";
    echo " <table class ='tabbord3'>\n";
    echo "  <tr class='th_headC'>\n";
    echo "   <td colspan='2'>".$title."<br>";
    HandleMSG();
    echo "</td>\n";
    echo "  </tr><tr class='th_headC'>\n";

    echo "  <td align='right'>Location: </td>\n";
    echo "  <td align='left'><input class='edit2' name='dbip' type='text' size='15'  maxlength='15' value='".$CFG_SERVER."'></td>\n";

    echo " </tr><tr class='th_headC'>\n";
    echo "  <td align='right' >User: </td>\n";
    echo "  <td align='left'><input class='edit2' name='dbuser' type='text' size='20'  maxlength='20' value='".$CFG_USER."'></td>\n";    

    echo " </tr><tr class='th_headC' >\n";
    echo "  <td align='right'>Password: </td>\n";
    echo "  <td align='left'><input class='edit2' name='dbpasswd' size='20' maxlength='20' type='text' value=''></td>\n";

    echo " </tr><tr class='th_headC'>\n";
    echo "  <td align='right'>Name: </td>\n";
    echo "  <td align='left'><input class='edit2' name='dbname' type='text' size='20'  maxlength='20' value='".$CFG_DATABASE."'></td>\n";    

    echo " </tr><tr class='th_headC'>\n";
    echo "  <td colspan='2' align='center'>\n";
    echo "   <input class='button1' type='submit' name='button' value='Save'></td>\n";
    echo " </tr>\n";
    echo " </table>\n";
    echo "</form>\n";
}
############################################################
function checkEditDatabase($nxStep,$oldDB=0){
############################################################
    $button     = (isset($_POST['button']))	? $_POST['button'] : "";
    $nextStep 	= 1;
    $nx 	= $nxStep;
    $bk 	= $nxStep - 1;
    if($button == "Save"){
	$dbip 		= (isset($_POST['dbip']))		? $_POST['dbip']: "localhost";
	$dbuser 	= (isset($_POST['dbuser']))		? $_POST['dbuser']: "";
	$dbpasswd 	= (isset($_POST['dbpasswd']))		? $_POST['dbpasswd']: "";
	$dbname 	= (isset($_POST['dbname']))		? $_POST['dbname']: "WebChessNG";
    	
	if(!$oldDB){
	    $newSetting = "<?PHP\n";
    	    $newSetting .= "$" . "CFG_SERVER   = '".$dbip."';\n";
    	    $newSetting .= "$" . "CFG_USER     = '".$dbuser."';\n";
    	    $newSetting .= "$" . "CFG_PASSWORD = '".$dbpasswd."';\n";
    	    $newSetting .= "$" . "CFG_DATABASE = '".$dbname."';\n";
    	    $newSetting .= "?>";
    	    $configfile = "conf/dbconfig.php";
	}else{
	    $newSetting = "<?PHP\n";
    	    $newSetting .= "$" . "CFG_SERVER_OLD   = '".$dbip."';\n";
    	    $newSetting .= "$" . "CFG_USER_OLD     = '".$dbuser."';\n";
    	    $newSetting .= "$" . "CFG_PASSWORD_OLD = '".$dbpasswd."';\n";
    	    $newSetting .= "$" . "CFG_DATABASE_OLD = '".$dbname."';\n";
    	    $newSetting .= "?>";
	    $configfile = "conf/dbconfig_old.php";
	}
    	writefile($configfile,$newSetting,0,0);

	//checkdbconnect
	if(!checkDBConnect()){
	    $nextStep = $bk;
	    $_SESSION["msg_error"] = "Can not connect to DB!";
	    return $nextStep;
	}else{
	    //checkdbname
	    if(!checkDBName($dbname)){
		if(!$oldDB){
		    //try to create DBName
		    if(!createDBName($dbname)){
		       	$nextStep = $bk;
	    	    	$_SESSION["msg_error"] = "Can not create DB '".$dbname."'!";
		    	return $nextStep;
		    }
		}else{
		    $nextStep = $bk;
		    $_SESSION["msg_error"] = "Can not read DB '".$dbname."'!";
		    return $nextStep;
		}
	    }
	    if(!$oldDB){
	    	//now create tables
	    	if(!createTables())
		    $nextStep = $bk;
	    	else
	            $nextStep = $nx;
	    }else
		$nextStep = $nx;
	}
    }
    return $nextStep;
}
############################################################
function createTables(){
############################################################
    $retval = 0;
    $sqlfile = "docs/tables/all_tables.sql";
    if(!file_exists($sqlfile)){
	$_SESSION["msg_error"] = "Can't insert tables!<br>File ".$sqlfile." not exist!";
	return $retval;
    }
    $fp = fopen($sqlfile,"r");
    if(!$fp){	
	$_SESSION["msg_error"] = "Can't insert tables!<br>Can't open file ".$sqlfile."!";
	return $retval;
    }else{
	while(!feof($fp))
	     $query .= fgets($fp);
	fclose ($fp);
    }

    $array = explode(';', $query);

    for($x = 0; $x < count($array)-1; $x++){
  	$array[$x] .= ";";
	if(!runSQLQuery($array[$x])){
	    $_SESSION["msg_error"] = "Can't insert tables!<br>See logs for more information!";
	    return $retval;
	}
    }
    $_SESSION["msg_ok"] = "Database and Tables are created!";
    $retval = 1;
    return $retval;
}

############################################################
function dispInsAdminUser($chkstep){
############################################################
    echo "<form name='install' method='post' action='install.php' accept-charset='UTF-8'>\n";
    echo "<input name='checkstep' value='".$chkstep."' type='hidden'>\n";
    echo " <table class ='tabbord3'>\n";
    echo "  <tr class='th_headC'>\n";
    echo "   <td colspan='2'>Create the Admin-user<br>";
    HandleMSG();
    echo "	</td>\n";
    echo "  </tr><tr class='th_headC'>\n";

    echo "  <td align='right'>Login name: </td>\n";
    echo "  <td align='left'><input class='edit2' name='logname' type='text' size='20'  maxlength='20' value=''></td>\n";

    echo " </tr><tr class='th_headC'>\n";
    echo "  <td align='right' >Login password: </td>\n";
    echo "  <td align='left'><input class='edit2' name='logpasswd' type='text' size='20'  maxlength='20' value=''></td>\n";    
    echo " </tr><tr class='th_headC'>\n";
    echo "  <td colspan='2' align='center'>\n";
    echo "   <input class='button1' type='submit' name='button' value='Save'></td>\n";

    echo "  </tr>\n";
    echo " </table>\n";
    echo "</form>\n";
}
############################################################
function checkInsAdminUser(){
############################################################
    $button     = (isset($_POST['button']))	? $_POST['button'] : "";
    $nextStep = 999;
    if($button == "Save"){
	$log_name	= (isset($_POST['logname']))		? $_POST['logname']: "";
	$log_passwd 	= (isset($_POST['logpasswd']))		? $_POST['logpasswd']: "";

	// create new user	
    	$md5passwd = md5($log_passwd);
    	$insStr  = "('','".$log_name."','".$md5passwd."',";
    	$insStr .= "'firstname','lastname',1,'mail',NOW(),NOW(),1)";
    	InsUser($insStr);
    
    	// get ID of new user 
    	$wheStr = "login_name = '".$log_name."' AND login_password = '".$md5passwd."'";
    	$tmpPlayers = SelUser("*",$wheStr);
    	$tmpPlayer = GetFetchArray($tmpPlayers);

    	$tmpPlayer['id'];

    	//set profile
    	$insStr  = "(".$tmpPlayer['id'].",1,'pgn','beholder','mail',0,120,50)";
    	InsUserProfile($insStr);
    }
    $_SESSION["msg_ok"] = "Admin-user created!";
    return $nextStep;
}

############################################################
function dispDBConvert(){
############################################################
    echo "<form name='install' method='post' action='install.php' accept-charset='UTF-8'>\n";
    echo "<input name='checkstep' value='102' type='hidden'>\n";
    echo " <table class ='tabbord3'>\n";
    echo "  <tr class='th_headC'>\n";
    echo "   <td>Now we can start the DB convert<br>";
    HandleMSG();
    echo "	</td>\n";
    echo "  </tr><tr class='th_headC'>\n";
    echo "   <td><input class='button1' name='button' type='submit' value='Start'></td>\n";
    echo "  </tr>\n";
    echo " </table>\n";
    echo "</form>\n";
}
############################################################
function checkDBConvert(){
############################################################
    $button	= (isset($_POST['button']))	? $_POST['button'] : "";
    $nextStep = 103;
    if($button == "Start"){


	// first convert players
	$tmpplayers = runOldSQLQuery("SELECT * FROM players;");
	
	$retval = 0;
    	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpplayer = GetFetchArray($tmpplayers)){
	    	//set user
	    	$md5passwd = md5($tmpplayer['password']);
    	    	$insStr  = "(".$tmpplayer['playerID'].",'".$tmpplayer['nick']."','".$md5passwd."',";
    	    	$insStr .= "'".$tmpplayer['firstName']."','".$tmpplayer['lastName']."',2,'',NOW(),NOW(),1)";
		
		$query = "INSERT INTO ".$GLOBALS[UserTB]." ".$GLOBALS[UserFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//    	    	InsUser($insStr);

	    	//set profile
    	    	$insStr  = "(".$tmpplayer['playerID'].",1,'pgn', 'beholder','',";
    	    	$insStr .= "0, ".$GLOBALS[CFG_MINAUTORELOAD].",".$GLOBALS[CFG_BOARDSQUARESIZE].")";	

		$query = "INSERT INTO ".$GLOBALS[UserProfileTB]." ".$GLOBALS[UserProfileFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//    	    	InsUserProfile($insStr);
	    }
	    mysql_close($dblink);
	}
 echo "User converted<br>\n";

	// Games
	$tmpgames = runOldSQLQuery("SELECT * FROM games;");

	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpgame = GetFetchArray($tmpgames)){
	    	$insStr = "(".$tmpgame['gameID'].",".$tmpgame['whitePlayer'].",".$tmpgame['blackPlayer']."";
	    	$insStr .= ",'".$tmpgame['gameMessage']."','".$tmpgame['messageFrom']."'";
	    	$insStr .= ",'".$tmpgame['dateCreated']."','".$tmpgame['lastMove']."'";
	    	$insStr .= ",".$tmpgame['msgforW'].",".$tmpgame['msgforB'].")";
		
		$query = "INSERT INTO ".$GLOBALS[GamesTB]." ".$GLOBALS[GamesFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}

//	    	InsGames($insStr);
	    }
	    mysql_close($dblink);
	}

 echo "Games converted<br>\n";

	// Games history
	$tmpgames = runOldSQLQuery("SELECT * FROM history;");

	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpgame = GetFetchArray($tmpgames)){
	    	$insStr  = "('".$tmpgame['timeOfMove']."',".$tmpgame['gameID'].",'".$tmpgame['curPiece']."'";
	    	$insStr .= ",'".$tmpgame['curColor']."',".$tmpgame['fromRow'].",".$tmpgame['fromCol']."";
	    	$insStr .= ",".$tmpgame['toRow'].",".$tmpgame['toCol'].",'".$tmpgame['replaced']."'";
	    	$insStr .= ",'".$tmpgame['promotedTo']."', ".$tmpgame['isInCheck'].",0)";

	    	$query = "INSERT INTO ".$GLOBALS[GamesHistoryTB]." ".$GLOBALS[GamesHistoryFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//		InsGamesHistory($insStr);
	    }
	    mysql_close($dblink);
	}	

 echo "Games History converted<br>\n";

	// Games pieces
	$tmpgames = runOldSQLQuery("SELECT * FROM pieces;");
	
	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpgame = GetFetchArray($tmpgames)){
	    	$insStr  = "(".$tmpgame['gameID'].",'".$tmpgame['color']."','".$tmpgame['piece']."'";
	    	$insStr .= ",".$tmpgame['col'].",".$tmpgame['row'].")";
	    	
		$query = "INSERT INTO ".$GLOBALS[GamesPiecesTB]." ".$GLOBALS[GamesPiecesFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//		InsGamesPieces($insStr);
	    }
	    mysql_close($dblink);
	}

 echo "Games Pieces converted<br>\n";


	// Games messages
	$tmpgames = runOldSQLQuery("SELECT * FROM messages;");

	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpgame = GetFetchArray($tmpgames)){
	    	$insStr  = "(".$tmpgame['msgID'].",".$tmpgame['gameID'].",'".$tmpgame['msgType']."'";
	    	$insStr .= ",'".$tmpgame['msgStatus']."','".$tmpgame['destination']."')";
	    	
		$query = "INSERT INTO ".$GLOBALS[GamesMessagesTB]." ".$GLOBALS[GamesMessagesFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//		InsGamesMessages($insStr);
	    }
	    mysql_close($dblink);
	}

 echo "Games messages converted<br>\n";	

	// User messages
	$tmpusers = runOldSQLQuery("SELECT * FROM chat;");

	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpuser = GetFetchArray($tmpusers)){
	    	$insStr  = "(".$tmpuser['msgID'].",".$tmpuser['playerID'].",".$tmpuser['gameID'].",0";
	    	$insStr .= ",'".htmlentities($tmpuser['message'], ENT_QUOTES, 'UTF-8')."',".$tmpuser['dateSent'].",0)";
	    	
		$query = "INSERT INTO ".$GLOBALS[UserMessagesTB]." ".$GLOBALS[UserMessagesFL]."";
    		$query .= " VALUES ".$insStr.";";

		$retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	if(!$retval){
	    	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    writeLog(ERROR, $line);
	    	}
//		InsUserMessages($insStr);
	    }
	    mysql_close($dblink);
	}

 echo "User messages converted<br>\n";

	// User statistic
	$tmpusers = runOldSQLQuery("SELECT * FROM elorating ORDER BY playerID, gameNR DESC;");
	$pID = 0;
	
	$dblink = mysql_connect($GLOBALS[CFG_SERVER],$GLOBALS[CFG_USER],$GLOBALS[CFG_PASSWORD]);
    	if($dblink){
	    while($tmpuser = GetFetchArray($tmpusers)){
	    	if ($pID != $tmpuser['playerID']){
		    $insStr  = "(".$tmpuser['gameNR'].",".$tmpuser['playerID'].",".$tmpuser['gameID'].",".$tmpuser['elorate'].",0";
	    	    $insStr .= ",0,'W','A',0,0)";

		    $query = "INSERT INTO ".$GLOBALS[StatisticTB]." ".$GLOBALS[StatisticFL]."";
    		    $query .= " VALUES ".$insStr.";";

		    $retval = mysql_db_query($GLOBALS[CFG_DATABASE],$query, $dblink);	
	    	    if(!$retval){
	    	    	$line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    	    	writeLog(ERROR, $line);
	    	    }
//	    	    InsStatistic($insStr);
		    $pID = $tmpuser['playerID'];
	      	}
	    }
	    mysql_close($dblink);
	}
 echo "User statistic converted<br>\n";

    } 
    return $nextStep;
}

############################################################
function dispEndScreen(){
############################################################
    echo "<form name='install' method='post' action='index.php' accept-charset='UTF-8'>\n";
    echo " <table class ='tabbord3'>\n";
    echo "  <tr class='th_headC'>\n";
    echo "   <td>Finished!<br>";
    HandleMSG();
    echo "	</td>\n";
    echo "  </tr><tr class='th_headC'>\n";

    echo "  <td>";
    echo "VERY IMPORTANT!<br>";
    echo "DELETE the 'install.php'<br>from the WebChessNG folder!<br><br>";
    echo "Now you can Login as the Admin user and make your configuration";
    echo "</td>\n";
 
    echo " </tr><tr class='th_headC'>\n";
    echo "  <td colspan='2' align='center'>\n";
    echo "   <input class='button1' type='button' name='button' value='Login' onClick=\"window.open('index.php','_self')\"></td>\n";
    
    echo "  </tr>\n";
    echo " </table>\n";
    echo "</form>\n";
}

############################################################
function runOldSQLQuery($query,$useDBName=1){
############################################################
    require "conf/dbconfig_old.php";
    $retval = 0;
    $dblink = mysql_connect($CFG_SERVER_OLD,$CFG_USER_OLD,$CFG_PASSWORD_OLD);
    if($dblink){
	if($useDBName)
    	    $retval = mysql_db_query($CFG_DATABASE_OLD,$query, $dblink);
	else
	    $retval = mysql_query($query, $dblink);	
	if(!$retval){
	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    writeLog(ERROR, $line);
	} 
	mysql_close($dblink);
    }else{
	$line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	writeLog(DB, $line);
	$_SESSION["msg_error"] = "Lost DB connection!<br>Try again later.";
    	require 'index.php'; 
    	die();
    }
    return $retval;
}

############################################################
function dispInstallPage() {
############################################################
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head>\n";
    echo "<meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n";
    echo " <title>WebChessNG - Create New User</title>\n";
    echo " <link rel='stylesheet' type='text/css' href='template/beholder/webchess.css'>\n";
    echo "</head><body>\n";
    echo "<center>\n";
    echo "<br><br><br><br>\n";
    echo "<table class ='tabbord1' width='400px' style='background-color: #D3D3D3' ><tr align='center'>\n";
    echo "<td>\n";
    echo "<table border='0'><tr><td>\n";
    echo "<h2>WebChessNG v".$GLOBALS[CFG_SOFT_VERSION]." Installation</h2>\n";
    echo "</td></tr></table>\n";

    installSteps();
    echo "</td>\n";
    echo " </tr>\n";
    echo "</table>\n";
    echo "</center>\n";
    echo "</body></html>\n";
}

dispInstallPage();

?>
