<?PHP
include_once('lib/dbwrapper.php');
include_once('lib/dbutils.php');
include_once('lib/statistic.php');
include_once('lib/mail.php');

/* these functions are used to interact with the DB */

############################################################
function updateTimestamp(){
############################################################
    UpdGames("lastMove = NOW()", "gameID = ".$_SESSION['gameID']."");
}

############################################################
function loadHistory(){
############################################################
    global $history, $numMoves;

    $allMoves = SelGamesHistory("*","gameID = ".$_SESSION['gameID']."","timeOfMove");
    $numMoves = -1;
    while ($thisMove = GetFetchArray($allMoves)){
	$numMoves++;
	$history[$numMoves] = $thisMove;
    }
}

############################################################
function savePromotion(){
############################################################
    global $history, $numMoves, $isInCheck;

    if ($isInCheck){
	$tmpIsInCheck = 1;
	$history[$numMoves]['isInCheck'] = 1;
    }else
	$tmpIsInCheck = 0;

    $history[$numMoves]['promotedTo'] = getPieceName($_POST['promotion']);

    $setStr = "promotedTo = '".getPieceName($_POST['promotion'])."', isInCheck = ".$tmpIsInCheck."";
    $wheStr = "gameID = ".$_SESSION['gameID']." AND timeOfMove = '".$history[$numMoves]['timeOfMove']."'";
    UpdGamesHistory($setStr, $wheStr);

    updateTimestamp();

    /* if email notification is activated and move does not result in a pawn's promotion... */
    if ($GLOBALS[CFG_USEEMAILNOTIFICATION]){
	if ($history[$numMoves]['replaced'] == null)
	    $tmpReplaced = '';
	else
	    $tmpReplaced = $history[$numMoves]['replaced'];

	/* get opponent's color */
	if (($numMoves == -1) || ($numMoves % 2 == 1))
	    $oppColor = "black";
	else
	    $oppColor = "white";

	/* get opponent's player ID */
	$opponentID = getGameOppId($oppColor, $_SESSION['gameID']);

	/* if opponent is using email notification... */
	$tmpMail = getUserMail($opponentID);
	if($tmpMail['mailnotify'] == 1){
	    /* get opponent's nick */
	    $opponentNick = getUserNick($_SESSION['playerID']);
	    /* get opponent's prefered history type */
	    $opponentHistory = getHistoryType($opponentID);
	    /* notify opponent of move via email */
	    if ($opponentHistory == 'pgn')
		webchessMail('move', $tmpMail['email'], moveToPGNString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, $history[$numMoves]['promotedTo'], $isInCheck), $opponentNick);
	    else
		webchessMail('move', $tmpMail['email'], moveToVerbousString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, $history[$numMoves]['promotedTo'], $isInCheck), $opponentNick);
	}
    }
}

############################################################
function saveHistory(){
############################################################
    global $board, $isPromoting, $history, $numMoves, $isInCheck, $CFG_USEEMAILNOTIFICATION;

    /* set destination row for pawn promotion */
    if ($board[$_POST['fromRow']][$_POST['fromCol']] & BLACK)
	$targetRow = 0;
    else
	$targetRow = 7;

    /* determine if move results in pawn promotion */
    if ((($board[$_POST['fromRow']][$_POST['fromCol']] & COLOR_MASK) == PAWN) && ($_POST['toRow'] == $targetRow))
	$isPromoting = true;
    else
	$isPromoting = false;

    /* determine who's playing based on number of moves so far */
    if (($numMoves == -1) || ($numMoves % 2 == 1)){
	$curColor = "white";
	$oppColor = "black";
	$targetRow = 7;
    }else{
	$curColor = "black";
	$oppColor = "white";
	$targetRow = 0;
    }

    /* add move to history */
    $numMoves++;
    $history[$numMoves]['gamedID'] = $_SESSION['gameID'];
    $history[$numMoves]['curPiece'] = getPieceName($board[$_POST['fromRow']][$_POST['fromCol']]);
    $history[$numMoves]['curColor'] = $curColor;
    $history[$numMoves]['fromRow'] = $_POST['fromRow'];
    $history[$numMoves]['fromCol'] = $_POST['fromCol'];
    $history[$numMoves]['toRow'] = $_POST['toRow'];
    $history[$numMoves]['toCol'] = $_POST['toCol'];
    $history[$numMoves]['promotedTo'] = null;

    if ($isInCheck)
	$history[$numMoves]['isInCheck'] = 1;
    else
	$history[$numMoves]['isInCheck'] = 0;

    if (DEBUG){
	if ($history[$numMoves]['curPiece'] == '')
	    echo ("WARNING!!!  missing piece at ".$_POST['fromRow'].", ".$_POST['fromCol'].": ".$board[$_POST['fromRow']][$_POST['fromCol']]."<p>\n");
    }

    if ($board[$_POST['toRow']][$_POST['toCol']] == 0){
	/* check capture piece by en-passant */
	if (($board[$_POST['fromRow']][$_POST['fromCol']] & COLOR_MASK) == PAWN 
		&& abs($_POST['toCol'] - $_POST['fromCol']) == 1){
	    $insStr  = "(Now(),".$_SESSION['gameID'].",'".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."'";
	    $insStr .= ", '$curColor', ".$_POST['fromRow'].", ".$_POST['fromCol'].", ".$_POST['toRow']."";
	    $insStr .= ", ".$_POST['toCol'].", '".getPieceName($board[$_POST['fromRow']][$_POST['toCol']])."'";
	    $insStr .= ", null, ".$history[$numMoves]['isInCheck'].",1)";

	    $history[$numMoves]['replaced'] = getPieceName($board[$_POST['fromRow']][$_POST['toCol']]);
	    $tmpReplaced = $history[$numMoves]['replaced'];
	}else{
	    $insStr  = "(Now(),".$_SESSION['gameID'].",'".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."'";
	    $insStr .= ", '$curColor', ".$_POST['fromRow'].", ".$_POST['fromCol'].", ".$_POST['toRow']."";
	    $insStr .= ", ".$_POST['toCol'].", null, null, ".$history[$numMoves]['isInCheck'].",0)";	

	    $history[$numMoves]['replaced'] = null;
	    $tmpReplaced = "";
	}
    }else{
	$insStr  = "(Now(),".$_SESSION['gameID'].",'".getPieceName($board[$_POST['fromRow']][$_POST['fromCol']])."'";
	$insStr .= ",'$curColor',".$_POST['fromRow'].",".$_POST['fromCol'].",".$_POST['toRow'].",".$_POST['toCol']."";
	$insStr .= ",'".getPieceName($board[$_POST['toRow']][$_POST['toCol']])."',null,".$history[$numMoves]['isInCheck'].",0)";
	
	$history[$numMoves]['replaced'] = getPieceName($board[$_POST['toRow']][$_POST['toCol']]);
	$tmpReplaced = $history[$numMoves]['replaced'];
    }
    InsGamesHistory($insStr);

    /* if email notification is activated and move does not result in a pawn's promotion... */
    /* NOTE: moves resulting in pawn promotion are handled by savePromotion() above */
    if ($CFG_USEEMAILNOTIFICATION && !$isPromoting){
	/* get opponent's player ID */
	$opponentID = getGameOppId($oppColor, $_SESSION['gameID']);

	/* if opponent is using email notification... */
	$tmpMail = getUserMail($opponentID);
	if($tmpMail['mailnotify'] == 1){
	    /* get opponent's nick */
	    $opponentNick = getUserNick($_SESSION['playerID']);
	    /* get opponent's prefered history type */
	    $opponentHistory = getHistoryType($opponentID);
	    /* notify opponent of move via email */
	    if ($opponentHistory == 'pgn')
		webchessMail('move', $tmpMail['email'], moveToPGNString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, '', $isInCheck), $opponentNick);
	    else
		webchessMail('move', $tmpMail['email'], moveToVerbousString($history[$numMoves]['curColor'], $history[$numMoves]['curPiece'], $history[$numMoves]['fromRow'], $history[$numMoves]['fromCol'], $history[$numMoves]['toRow'], $history[$numMoves]['toCol'], $tmpReplaced, '', $isInCheck), $opponentNick);
	  
	}
    }
}

############################################################
function loadGame(){
############################################################
    global $board, $playersColor;


    /* clear board data */
    for ($i = 0; $i < 8; $i++)
	for ($j = 0; $j < 8; $j++)
	    $board[$i][$j] = 0;

    /* get data from database */
    $pieces = SelGamesPieces("*","gameID = ".$_SESSION['gameID']."");

    /* setup board */
    while ($thisPiece = GetFetchArray($pieces)){
	$board[$thisPiece["row"]][$thisPiece["col"]] = getPieceCode($thisPiece["color"], $thisPiece["piece"]);
    }

    /* get current player's color */
    $tmpTurns = SelGames("whitePlayer, blackPlayer","gameID = ".$_SESSION['gameID']."");
    $tmpTurn = GetFetchArray($tmpTurns);

    if ($tmpTurn['whitePlayer'] == $_SESSION['playerID'])
	$playersColor = "white";
    else if($tmpTurn['blackPlayer'] == $_SESSION['playerID'])
	$playersColor = "black";
    else //ended games or admin view
	$playersColor = "white";
}

############################################################
function saveGame(){
############################################################
    global $board, $playersColor;

    /* clear old data */
    DelGamesPieces("gameID = ".$_SESSION['gameID']."");

    /* save new game data */
    /* for each row... */
    for ($i = 0; $i < 8; $i++){
	/* for each col... */
	for ($j = 0; $j < 8; $j++){
	    /* if there's a piece at that pos on the board */
	    if ($board[$i][$j] != 0){
		/* updated the database */
		if ($board[$i][$j] & BLACK)
		    $tmpColor = "black";
		else
		    $tmpColor = "white";

		$tmpPiece = getPieceName($board[$i][$j]);
		InsGamesPieces("(".$_SESSION['gameID'].", '".$tmpColor."', '".$tmpPiece."', ".$j.", ".$i.")");
	    }
	}
    }
    /* update lastMove timestamp */
    updateTimestamp();
}

############################################################
function processMessages(){
############################################################
    global $isUndoRequested, $isDrawRequested, $isUndoing, $isGameOver, $isCheckMate, $playersColor, $numMoves, $statusMessage, $CFG_USEEMAILNOTIFICATION, $requestPending;


    if (DEBUG)
	echo("Entering processMessages()<br>\n");

    $isUndoRequested = false;
    $isGameOver = false;

    /* find out which player (black or white) we are serving */
    /* NOTE: When playing in the same computer $playersColor is always the player who logged in first */
    if (DEBUG)
	echo("SharedPC..." . $_SESSION['isSharedPC'] . "<br>\n");
    if ($_SESSION['isSharedPC'])	// Only the player to move is active in this case
	if( ( (($numMoves == -1) || (($numMoves % 2) == 1)) && ($playersColor == "white")) ||
				((($numMoves % 2) == 0) && ($playersColor == "black")) )
	    $currentPlayer = $playersColor;
	else						// The player who logged in later is to move
	    if($playersColor == "white")
		$currentPlayer = "black";
	    else
		$currentPlayer = "white";
    else 							// The players are on different computers
	$currentPlayer = $playersColor;

    if ($currentPlayer == "white")
	$opponentColor = "black";
    else
	$opponentColor = "white";

    /* *********************************************** */
    /* queue user generated (ie: using forms) messages */
    /* *********************************************** */
    if (DEBUG)
	echo("Processing user generated (ie: form) messages...<br>\n");

    /* queue a request for an undo */
    if ($_POST['requestUndo'] == "yes"){
	//write log
	$logmess = "Request Undo for gameID: ".$_SESSION['gameID'];
	writeLog(EVENT,$logmess);

	/* if the two players are on the same system, execute undo immediately */
	/* NOTE: assumes the two players discussed it live before undoing */
	if ($_SESSION['isSharedPC'])
	    $isUndoing = true;
	else{
	    InsGamesMessages("('',".$_SESSION['gameID'].", 'undo', 'request', '".$opponentColor."')");
	}
	
	//set request flag
	$tmpGameID = SelGames("*","gameID = ".$_SESSION['gameID']."");
  	$tmpGameID = GetFetchArray($tmpGameID);

	if ( $tmpGameID['blackPlayer'] == $_SESSION['playerID']){
	    if(($tmpGameID['msgforW'] & 2) != 2){
	    	$tmpmsg = $tmpGameID['msgforW'] + 2;
		UpdGames("msgforW = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    }
	}else{
	    if(($tmpGameID['msgforB'] & 2) != 2){
	    	$tmpmsg = $tmpGameID['msgforB'] + 2;
		UpdGames("msgforB = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    }
	}

	updateTimestamp();
    }

    /* queue a request for a draw */
    if ($_POST['requestDraw'] == "yes"){
	//write log
	$logmess = "Request Draw for gameID: ".$_SESSION['gameID'];
	writeLog(EVENT,$logmess);

	/* if the two players are on the same system, execute Draw immediately */
	/* NOTE: assumes the two players discussed it live before declaring the game a draw */
	if ($_SESSION['isSharedPC']){
	    UpdGamesMessages("gameMessage = 'draw',messageFrom = '".$currentPlayer."'","gameID = ".$_SESSION['gameID']."");
	}else{
	    InsGamesMessages("('',".$_SESSION['gameID'].", 'draw', 'request', '".$opponentColor."')");
	}
	
	//set request flag
	$tmpGameID = SelGames("*","gameID = ".$_SESSION['gameID']."");
  	$tmpGameID = GetFetchArray($tmpGameID);

	if ( $tmpGameID['blackPlayer'] == $_SESSION['playerID']){
	    if(($tmpGameID['msgforW'] & 2) != 2){
	    	$tmpmsg = $tmpGameID['msgforW'] + 2;
		UpdGames("msgforW = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    }
	}else{
	    if(($tmpGameID['msgforB'] & 2) != 2){
	    	$tmpmsg = $tmpGameID['msgforB'] + 2;
		UpdGames("msgforB = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    }
	}
	updateTimestamp();
    }

    /* response to a request for an undo */
    if (isset($_POST['undoResponse'])){
	if ($_POST['isUndoResponseDone'] == 'yes'){
	    if ($_POST['undoResponse'] == "yes"){
		$tmpStatus = "approved";
		$isUndoing = true;
		$logmess = "Undo Response approved for gameID: ".$_SESSION['gameID'];
	    }else{
		$tmpStatus = "denied";
		$logmess = "Undo Response denied for gameID: ".$_SESSION['gameID'];
	    }
	    //write log
	    writeLog(EVENT,$logmess);	    
	    
   	    $steStr  = "msgStatus = '".$tmpStatus."', destination = '".$opponentColor."'";
	    $wheStr  = "gameID = ".$_SESSION['gameID']." AND msgType = 'undo'";
	    $wheStr .= " AND msgStatus = 'request' AND destination = '".$currentPlayer."'";
	    UpdGamesMessages($steStr,$wheStr); 
	
	    //remove request flag
	    $tmpGameID = SelGames("*","gameID = ".$_SESSION['gameID']."");
  	    $tmpGameID = GetFetchArray($tmpGameID);

	    if ( $tmpGameID['blackPlayer'] == $_SESSION['playerID']){
	    	if(($tmpGameID['msgforB'] & 2) == 2){
	    	    $tmpmsg = $tmpGameID['msgforB'] - 2;
		    UpdGames("msgforB = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    	}
	    }else{
	    	if(($tmpGameID['msgforW'] & 2) == 2){
	    	    $tmpmsg = $tmpGameID['msgforW'] - 2;
		    UpdGames("msgforW = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    	}
	    }
	    updateTimestamp();
	}
    }

    /* response to a request for a draw */
    if (isset($_POST['drawResponse'])){
	if ($_POST['isDrawResponseDone'] == 'yes'){
	    if ($_POST['drawResponse'] == "yes"){
		$tmpStatus = "approved";
		UpdGames("gameMessage = 'draw', messageFrom = '".$currentPlayer."'","gameID = ".$_SESSION['gameID']."");
		calcEloRating(); //new EloRating function
		delUserMsgByGameId($_SESSION['gameID']);
		$logmess = "Draw Response approved for gameID: ".$_SESSION['gameID'];
	    }else{
		$tmpStatus = "denied";
		$logmess = "Draw Response approved for gameID: ".$_SESSION['gameID'];
	    }
	    //write log
	    writeLog(EVENT,$logmess);
	    
	    $setStr = "msgStatus = '".$tmpStatus."', destination = '".$opponentColor."'";
	    $wheStr = "gameID = ".$_SESSION['gameID']." AND msgType = 'draw' AND msgStatus = 'request' AND destination = '".$currentPlayer."'"; 
	    UpdGamesMessages($setStr, $wheStr);
	
	    //remove request flag
	    $tmpGameID = SelGames("*","gameID = ".$_SESSION['gameID']."");
  	    $tmpGameID = GetFetchArray($tmpGameID);

	    if ( $tmpGameID['blackPlayer'] == $_SESSION['playerID']){
	    	if(($tmpGameID['msgforB'] & 2) == 2){
	    	    $tmpmsg = $tmpGameID['msgforB'] - 2;
		    UpdGames("msgforB = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    	}
	    }else{
	    	if(($tmpGameID['msgforW'] & 2) == 2){
	    	    $tmpmsg = $tmpGameID['msgforW'] - 2;
		    UpdGames("msgforW = ".$tmpmsg."","gameID = ".$_SESSION['gameID']."");
	    	}
	    }
	    updateTimestamp();
	}
    }

    /* resign the game */
    if ($_POST['resign'] == "yes"){
	//write log
	$logmess = "Resign the gameID: ".$_SESSION['gameID'];
	writeLog(EVENT,$logmess);
	UpdGames("gameMessage = 'playerResigned',messageFrom = '".$currentPlayer."'","gameID = ".$_SESSION['gameID']."");
	updateTimestamp();
	calcEloRating(); //new EloRating function
	delUserMsgByGameId($_SESSION['gameID']);

	/* if email notification is activated... */
	if ($CFG_USEEMAILNOTIFICATION){
	    /* get opponent's player ID */
	    $opponentID = getGameOppId($currentPlayer, $_SESSION['gameID']);
		
	    /* if opponent is using email notification... */
	    $tmpMail = getUserMail($opponentID);
	    if($tmpMail['mailnotify'] == 1)
  		webchessMail('resignation', $tmpMail['email'], '', $_SESSION['nick']);
	}
    }

    /* ******************************************* */
    /* process queued messages (ie: from database) */
    /* ******************************************* */
    $tmpMessages = SelGamesMessages("*","gameID = ".$_SESSION['gameID']." AND destination = '".$currentPlayer."'");
    while($tmpMessage = GetFetchArray($tmpMessages)){
	switch($tmpMessage['msgType']){
	    case 'undo':
		switch($tmpMessage['msgStatus']){
		    case 'request':
			$isUndoRequested = true;
			break;
		    case 'approved':
			$wheStr  = "gameID = ".$_SESSION['gameID']." AND msgType = 'undo'";
			$wheStr .= " AND msgStatus = 'approved' AND destination = '".$currentPlayer."'";
			DelGamesMessages($wheStr);
			$statusMessage .= $_SESSION['TXT']['Undo']." ".$_SESSION['TXT']['Approved'];
			$requestPending = false;
			break;
		    case 'denied':
			$isUndoing = false;
			$wheStr  = "gameID = ".$_SESSION['gameID']." AND msgType = 'undo'";
			$wheStr .= " AND msgStatus = 'denied' AND destination = '".$currentPlayer."'";
			DelGamesMessages($wheStr);
			$statusMessage .= $_SESSION['TXT']['Undo']." ".$_SESSION['TXT']['Denied'];
			$requestPending = false;
			break;
		}
		break;

	    case 'draw':
		switch($tmpMessage['msgStatus']){
		    case 'request':
			$isDrawRequested = true;
			break;
		    case 'approved':
			$wheStr  = "gameID = ".$_SESSION['gameID']." AND msgType = 'draw'";
			$wheStr .= " AND msgStatus = 'approved' AND destination = '".$currentPlayer."'";
			DelGamesMessages($wheStr);
			$statusMessage .= $_SESSION['TXT']['Draw']." ".$_SESSION['TXT']['Approved'];
			$requestPending = false;
			break;
		    case 'denied':
			$wheStr  = "gameID = ".$_SESSION['gameID']." AND msgType = 'draw'";
			$wheStr .= " AND msgStatus = 'denied' AND destination = '".$currentPlayer."'";
			DelGamesMessages($wheStr);
			$statusMessage .= $_SESSION['TXT']['Draw']." ".$_SESSION['TXT']['Denied'];
			$requestPending = false;
			break;
		}
		break;
	}
    }

    /* requests pending */
    $wheStr  = "gameID = ".$_SESSION['gameID']." AND msgStatus = 'request' AND destination = '".$opponentColor."'";
    $tmpMessages = SelGamesMessages("*",$wheStr); 	
    while($tmpMessage = GetFetchArray($tmpMessages)){
	switch($tmpMessage['msgType']){
	    case 'undo':
		$statusMessage .= $_SESSION['TXT']['UndoRequestPending'];
		$requestPending = true;
		break;
	    case 'draw':
		$statusMessage .= $_SESSION['TXT']['DrawRequestPending'];
		$requestPending = true;
		break;
	}
    }

    /* game level status: draws, resignations and checkmate */
    /* if checkmate, update games table */
    if ($_POST['isCheckMate'] == 'true'){
	//write log
	$logmess = "CheckMate the gameID: ".$_SESSION['gameID'];
	writeLog(EVENT,$logmess);
	$setStr = "gameMessage = 'checkMate', messageFrom = '".$currentPlayer."'";
	$wheStr = "gameID = ".$_SESSION['gameID']."";
	UpdGames($setStr,$wheStr);
        calcEloRating(); //new EloRating function
	delUserMsgByGameId($_SESSION['gameID']);
    }
    $tmpMessages =	SelGames("gameMessage, messageFrom","gameID = ".$_SESSION['gameID']."");
    $tmpMessage = GetFetchArray($tmpMessages);
    if ($tmpMessage['messageFrom'] == "white")
	$color = $_SESSION['TXT']['White'];
    else
	$color = $_SESSION['TXT']['Black'];

    if ($tmpMessage['gameMessage'] == "draw"){
	$statusMessage .= $_SESSION['TXT']['EndedInDraw'];
	$isGameOver = true;
    }

    if ($tmpMessage['gameMessage'] == "playerResigned"){
	$statusMessage .= $color." ".$_SESSION['TXT']['EndedHasRes'];
	$isGameOver = true;
    }

    if ($tmpMessage['gameMessage'] == "checkMate"){
	$statusMessage .= "".$_SESSION['TXT']['EndedCheckmate']." ".$color." ".$_SESSION['TXT']['EndedHasWon'];
	$isGameOver = true;
	$isCheckMate = true;
    }
}

?>
