<?PHP

include_once('lib/utils.php');

$DB_WRAPPER_VERSION	= "1.1";

//Database Table names and fields
$UserTB 	= "user";
$UserFL		= "(id,login_name,login_password,first_name,last_name,user_group_id,regmail,registration,last_online,active)";

$UserGroupTB 	= "user_group";
$UserGroupFL 	= "(description)";

$UserProfileTB	= "user_profile";
$UserProfileFL	= "(user_id,language_id,history,theme,email,emailnotify,autoreload,bsize)";

$UserMessagesTB	= "user_messages";
$UserMessagesFL	= "(id,from_user_id,to_game_id,to_user_id,message,dateSent,unread)";

$GamesTB	= "games";
$GamesFL	= "(gameID,whitePlayer,blackPlayer,gameMessage,messageFrom,dateCreated,lastMove,msgforW,msgforB)";

$GamesHistoryTB	= "games_history";
$GamesHistoryFL	= "(timeOfMove,gameID,curPiece,curColor,fromRow,fromCol,toRow,toCol,replaced,promotedTo,isInCheck,isEnPassant)";

$GamesMessagesTB= "games_messages";
$GamesMessagesFL= "(msgID,gameID,msgType,msgStatus,destination)";

$GamesPiecesTB	= "games_pieces";
$GamesPiecesFL	= "(gameID,color,piece,col,row)";

$StatisticTB	= "user_statistic";
$StatisticFL	= "(id,user_id,game_id,elo_rate,elo_change,user_id_opp,user_color,result,game_abort,turn_freq)";

$LanguageTB	= "language";
$LanguageFL	= "(description,short_description)";

$VersionTB	= "version";
$VersionFL	= "(software,database)";

############################################################
function checkDBConnect(){
############################################################
    require "conf/dbconfig.php";
    $retval = 0;
    $dblink = mysql_connect($CFG_SERVER,$CFG_USER,$CFG_PASSWORD);
    if($dblink){
    	$retval = 1;
	mysql_close($dblink);
    }else{
	$retval = 0;
	$line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	writeLog(ERROR, $line);
    }
    return $retval;
}

############################################################
function checkDBName($dbname){
############################################################
    require "conf/dbconfig.php";
    $retval = 0;
    $dblink = mysql_connect($CFG_SERVER,$CFG_USER,$CFG_PASSWORD);
    if($dblink){
    	$retval = mysql_select_db($dbname);
	mysql_close($dblink);
    }
    return $retval;
}

############################################################
function runSQLQuery($query,$useDBName=1){
############################################################
    require "conf/dbconfig.php";
    $retval = 0;
    $dblink = mysql_connect($CFG_SERVER,$CFG_USER,$CFG_PASSWORD);
    if($dblink){
	if($useDBName)
    	    $retval = mysql_db_query($CFG_DATABASE,$query, $dblink);
	else
	    $retval = mysql_query($query, $dblink);	
	if(!$retval){
	    $line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	    writeLog(ERROR, $line);
	} 
	mysql_close($dblink);
    }else{
	$line = "DBErrorNo.: ".mysql_errno()." - ".mysql_error();
	writeLog(DB, $line);
	$_SESSION["msg_error"] = "Lost DB connection!<br>Try again later.";
    	require 'index.php'; 
    	die();
    }
    return $retval;
}

############################################################
function createDBName($dbname){
############################################################
    $query = "CREATE DATABASE `".$dbname."` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;";
    $retval=runSQLQuery($query,0);
    if(!$retval) return 0; else return $retval;
}

############################################################
function selSQLQuery($tab, $sel, $whe, $ord){
############################################################
    $query = "SELECT ".$sel." FROM ".$tab."";
    if($whe != "") $query .= " WHERE ".$whe."";
    if($ord != "") $query .= " ORDER BY ".$ord."";
    $query .= ";";
    writeLog(DB, $query);
    $retval=runSQLQuery($query);
    if(!$retval) return 0; else return $retval;
}
############################################################
function insSQLQuery($tab, $fld, $data){
############################################################
    $query = "INSERT INTO ".$tab." ".$fld."";
    $query .= " VALUES ".$data.";";
    writeLog(DB, $query);
    $retval=runSQLQuery($query);	
    if(!$retval)return 0; else return $retval;
}
############################################################
function delSQLQuery($tab, $whe){
############################################################
    $query = "DELETE FROM ".$tab." WHERE ".$whe.";";
    writeLog(DB, $query);
    if(!$retval=runSQLQuery($query))return 0; else return $retval;
}
############################################################
function updSQLQuery($tab, $set, $whe){
############################################################
    $query = "UPDATE ".$tab." SET ".$set." WHERE ".$whe.";";
    writeLog(DB, $query);
    $retval=runSQLQuery($query);
    if(!$retval)return 0; else return $retval;
}

############################################################
function GetNumRows($result){
############################################################
    return mysql_num_rows($result);
}

############################################################
function GetFetchArray($result){
############################################################
    return mysql_fetch_array($result, MYSQL_BOTH);
}
############################################################
function SelGen($sel="*",$from="",$whe="",$ord=""){
############################################################
    return selSQLQuery($from, $sel, $whe, $ord);
}


############################################################
function SelUser($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[UserTB], $sel, $whe, $ord);
}
############################################################
function InsUser($data){
############################################################
    return insSQLQuery($GLOBALS[UserTB], $GLOBALS[UserFL], $data);
}
############################################################
function DelUser($whe=""){
############################################################
    return delSQLQuery($GLOBALS[UserTB], $whe);
}
############################################################
function UpdUser($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[UserTB], $set, $whe);
}



############################################################
function SelUserGroup($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[UserGroupTB], $sel, $whe, $ord);
}
############################################################
function InsUserGroup($data){
############################################################
    return insSQLQuery($GLOBALS[UserGroupTB], $GLOBALS[UserGroupFL], $data);
}
############################################################
function DelUserGroup($whe=""){
############################################################
    return delSQLQuery($GLOBALS[UserGroupTB], $whe);
}
############################################################
function UpdUserGroup($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[UserGroupTB], $set, $whe);
}



############################################################
function SelUserProfile($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[UserProfileTB], $sel, $whe, $ord);
}
############################################################
function InsUserProfile($data){
############################################################
    return insSQLQuery($GLOBALS[UserProfileTB], $GLOBALS[UserProfileFL], $data);
}
############################################################
function DelUserProfile($whe=""){
############################################################
    return delSQLQuery($GLOBALS[UserProfileTB], $whe);
}
############################################################
function UpdUserProfile($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[UserProfileTB], $set, $whe);
}



############################################################
function SelGames($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[GamesTB], $sel, $whe, $ord);
}
############################################################
function InsGames($data){
############################################################
    return insSQLQuery($GLOBALS[GamesTB], $GLOBALS[GamesFL], $data);
}
############################################################
function DelGames($whe=""){
############################################################
    return delSQLQuery($GLOBALS[GamesTB], $whe);
}
############################################################
function UpdGames($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[GamesTB], $set, $whe);
}



############################################################
function SelGamesHistory($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[GamesHistoryTB], $sel, $whe, $ord);
}
############################################################
function InsGamesHistory($data){
############################################################
    return insSQLQuery($GLOBALS[GamesHistoryTB], $GLOBALS[GamesHistoryFL], $data);
}
############################################################
function DelGamesHistory($whe=""){
############################################################
    return delSQLQuery($GLOBALS[GamesHistoryTB], $whe);
}
############################################################
function UpdGamesHistory($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[GamesHistoryTB], $set, $whe);
}



############################################################
function SelGamesMessages($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[GamesMessagesTB], $sel, $whe, $ord);
}
############################################################
function InsGamesMessages($data){
############################################################
    return insSQLQuery($GLOBALS[GamesMessagesTB], $GLOBALS[GamesMessagesFL], $data);
}
############################################################
function DelGamesMessages($whe=""){
############################################################
    return delSQLQuery($GLOBALS[GamesMessagesTB], $whe);
}
############################################################
function UpdGamesMessages($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[GamesMessagesTB], $set, $whe);
}



############################################################
function SelGamesPieces($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[GamesPiecesTB], $sel, $whe, $ord);
}
############################################################
function InsGamesPieces($data){
############################################################
    return insSQLQuery($GLOBALS[GamesPiecesTB], $GLOBALS[GamesPiecesFL], $data);
}
############################################################
function DelGamesPieces($whe=""){
############################################################
    return delSQLQuery($GLOBALS[GamesPiecesTB], $whe);
}
############################################################
function UpdGamesPieces($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[GamesPiecesTB], $set, $whe);
}



############################################################
function SelUserMessages($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[UserMessagesTB], $sel, $whe, $ord);
}
############################################################
function InsUserMessages($data){
############################################################
    return insSQLQuery($GLOBALS[UserMessagesTB], $GLOBALS[UserMessagesFL], $data);
}
############################################################
function DelUserMessages($whe=""){
############################################################
    return delSQLQuery($GLOBALS[UserMessagesTB], $whe);
}
############################################################
function UpdUserMessages($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[UserMessagesTB], $set, $whe);
}



############################################################
function SelStatistic($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[StatisticTB], $sel, $whe, $ord);
}
############################################################
function InsStatistic($data){
############################################################
    return insSQLQuery($GLOBALS[StatisticTB], $GLOBALS[StatisticFL], $data);
}
############################################################
function DelStatistic($whe=""){
############################################################
    return delSQLQuery($GLOBALS[StatisticTB], $whe);
}
############################################################
function UpdStatistic($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[StatisticTB], $set, $whe);
}



############################################################
function SelLanguage($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[LanguageTB], $sel, $whe, $ord);
}
############################################################
function InsLanguage($data){
############################################################
    return insSQLQuery($GLOBALS[LanguageTB], $GLOBALS[LanguageFL], $data);
}
############################################################
function DelLanguage($whe=""){
############################################################
    return delSQLQuery($GLOBALS[LanguageTB], $whe);
}
############################################################
function UpdLanguage($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[LanguageTB], $set, $whe);
}



############################################################
function SelVersion($sel="*",$whe="",$ord=""){
############################################################
    return selSQLQuery($GLOBALS[VersionTB], $sel, $whe, $ord);
}
############################################################
function InsVersionUsr($data){
############################################################
    return insSQLQuery($GLOBALS[VersionTB], $GLOBALS[VersionFL], $data);
}
############################################################
function DelVersion($whe=""){
############################################################
    return delSQLQuery($GLOBALS[VersionTB], $whe);
}
############################################################
function UpdVersion($set="", $whe=""){
############################################################
    return updSQLQuery($GLOBALS[VersionTB], $set, $whe);
}


?>
