<?PHP


############################################################
function calcEloRating($gameID='',$aborted=0){
############################################################
    if($gameID == ''){
	$gameID = $_SESSION['gameID'];
	if (!checkGoodGame($gameID))
	return;
    }
    
    $logmess = "Enter calcEloRating (gameid = ".$gameID.", aborted = ".$aborted.")";
    writeLog(STAT,$logmess);
    
    //check if start elo rate is changed
    changeStartRate();

    require 'conf/ELOconfig.php';

    //get ending game information
    $BlackP = array();
    $WhiteP = array();
    $tmpplayerID = SelGames("*","gameID = ".$gameID."");
    $tmpplayerID = GetFetchArray($tmpplayerID);
    $BlackP['pID'] 		= $tmpplayerID['blackPlayer'];
    $WhiteP['pID'] 		= $tmpplayerID['whitePlayer'];

    //get old elorating info
    $wheStr = "user_id = ".$tmpplayerID['blackPlayer']."";
    $ordStr = "id DESC";
    $tmpElorating = SelStatistic("*",$wheStr,$ordStr);
    $rows = GetNumRows($tmpElorating);
    if ($rows == 0){
  	$BlackP['elo_rate'] 	= $CFG_ELO_START_RATE;
  	$BlackP['id'] 		= 0;
    }else{
  	$tmpElorating = GetFetchArray($tmpElorating);
  	$BlackP['elo_rate'] 	= $tmpElorating['elo_rate'];
  	$BlackP['id'] 		= $tmpElorating['id'];
    }
    if($BlackP['elo_rate'] < 2000)
  	$BlackP['constat'] 	= 30;
    else if($BlackP['elo_rate'] > 2400)
  	$BlackP['constat'] 	= 10;
    else
	$BlackP['constat'] 	= 130 - ($BlackP['elo_rate'] / 20);
	
    $logmess = "Black  PID:".$BlackP['pID']." OldElo:".$BlackP['elo_rate']." Constat:".$BlackP['constat']."";
    writeLog(STAT,$logmess);

    $wheStr = "user_id = ".$tmpplayerID['whitePlayer']."";
    $ordStr = "id DESC";
    $tmpElorating = SelStatistic("*",$wheStr,$ordStr);
    $rows = GetNumRows($tmpElorating);
    if ($rows == 0){
  	$WhiteP['elo_rate'] 	= $CFG_ELO_START_RATE;
  	$WhiteP['id'] 		= 0;
    }else{
  	$tmpElorating = GetFetchArray($tmpElorating);
  	$WhiteP['elo_rate'] 	= $tmpElorating['elo_rate'];
  	$WhiteP['id'] 		= $tmpElorating['id'];
    }
    if($WhiteP['elo_rate'] < 2000)
  	$WhiteP['constat'] 	= 30;
    else if($WhiteP['elo_rate'] > 2400)
  	$WhiteP['constat'] 	= 10;
    else
	$WhiteP['constat'] 	= 130 - ($WhiteP['elo_rate'] / 20);

    $logmess = "White  PID:".$WhiteP['pID']." OldElo:".$WhiteP['elo_rate']." Constat:".$WhiteP['constat']."";
    writeLog(STAT,$logmess);

    // elo calculation as discript on "http://gobase.org/studying/articles/elo/"
    $ELODIFFARRAY 	= array(   0,   20,   40,   60,   80,  100,  120,  140,  160,  180,  200,  300,  400);
    $EXPSCOREARRAY 	= array( 0.5, 0.53, 0.58, 0.62, 0.66, 0.69, 0.73, 0.76, 0.79, 0.82, 0.84, 0.93, 0.97);

    if($WhiteP['elo_rate'] < $BlackP['elo_rate'])
  	$playerdiff = $BlackP['elo_rate'] - $WhiteP['elo_rate'];
    else
  	$playerdiff = $WhiteP['elo_rate'] - $BlackP['elo_rate'];

    $expScore = 0;
    for ($i = 0; $i < 13; $i++) {
	if( $playerdiff < $ELODIFFARRAY[$i])
  	    break;
  	$expScore = $EXPSCOREARRAY[$i];
    }
    $expScore2 = 1 - $expScore;

    $logmess = "PlayerDiff:".$playerdiff." expectedScore1:".$expScore." expectedScore2:".$expScore2."";
    writeLog(STAT,$logmess);

    $updownrate = 0;
    $BlackP['game_abort'] = 0;
    $WhiteP['game_abort'] = 0;
    switch ($tmpplayerID['gameMessage']) {
  	case 'draw':
  	    //in a draw are the points only the half worth
  	    $WhiteP['constat'] = $WhiteP['constat'] / 2;
  	    $BlackP['constat'] = $BlackP['constat'] / 2;
	    $WhiteP['result'] = "R";
	    $BlackP['result'] = "R";

  	    if ( $WhiteP['elo_rate'] == $BlackP['elo_rate'] ){
  		$WhiteP['new_elo_rate'] = $WhiteP['elo_rate'];
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'];
		$WhiteP['new_elo_change'] = 0;
		$BlackP['new_elo_change'] = 0;
		$logmess  = "DRAW | WhiteElo == BlackElo | ";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
    		writeLog(STAT,$logmess);
  	    }else if( $WhiteP['elo_rate'] < $BlackP['elo_rate'] ){//black has a better skill level
  		$updownrate = round($WhiteP['constat'] * ($expScore - $expScore2));
  		$WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] + $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] - $updownrate;
		$WhiteP['new_elo_change'] = +$updownrate;
		$BlackP['new_elo_change'] = -$updownrate;
		$logmess  = "DRAW | WhiteElo < BlackElo | ";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
    		writeLog(STAT,$logmess);
  	    }else{                                              //white has a better skill level
  		$updownrate = round($BlackP['constat'] * ($expScore - $expScore2));
                $WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] - $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] + $updownrate;
		$WhiteP['new_elo_change'] = -$updownrate;
		$BlackP['new_elo_change'] = +$updownrate;
		$logmess  = "DRAW | WhiteElo > BlackElo | ";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
    		writeLog(STAT,$logmess);
            }
            break;
	case 'playerResigned':
            if($tmpplayerID['messageFrom'] == 'white'){ 	//white loose the game
            	if ( $WhiteP['elo_rate'] == $BlackP['elo_rate'] ){ //both player have the same skill level
            	    $updownrate = round($BlackP['constat'] * $expScore);
		    $logmess = "White Resigned | WhiteElo == BlackElo | ";
		}else if( $WhiteP['elo_rate'] < $BlackP['elo_rate'] ){//black has a better skill level
                    $updownrate = round($BlackP['constat'] * (1 - $expScore));
		    $logmess = "White Resigned | WhiteElo < BlackElo | ";
		}else{                                              //white has a better skill level
                    $updownrate = round($BlackP['constat'] * $expScore);
		    $logmess = "White Resigned | WhiteElo > BlackElo | ";
		}

                $WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] - $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] + $updownrate;
		$WhiteP['new_elo_change'] = -$updownrate;
		$BlackP['new_elo_change'] = +$updownrate;
		$WhiteP['result'] = "L";
	    	$BlackP['result'] = "W";
  		$WhiteP['game_abort'] = $aborted;
		if($aborted == 1)
		    $WhiteP['result'] = "A";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
    		writeLog(STAT,$logmess);
  	    }else{  							//black loose the game
		if ( $WhiteP['elo_rate'] == $BlackP['elo_rate'] ){		//both player have the same skill level
            	    $updownrate = round($WhiteP['constat'] * $expScore);
		    $logmess = "Black Resigned | WhiteElo == BlackElo | ";
		}else if( $WhiteP['elo_rate'] < $BlackP['elo_rate'] ){  		//black has a better skill level
                    $updownrate = round($WhiteP['constat'] * $expScore);
		    $logmess = "Black Resigned | WhiteElo < BlackElo | ";
		}else{                                                     	//white has a better skill level
                    $updownrate = round($WhiteP['constat'] * (1 - $expScore));
		    $logmess = "Black Resigned | WhiteElo > BlackElo | ";
		}

                $WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] + $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] - $updownrate;
		$WhiteP['new_elo_change'] = +$updownrate;
		$BlackP['new_elo_change'] = -$updownrate;
		$WhiteP['result'] = "W";
	    	$BlackP['result'] = "L";
  		$BlackP['game_abort'] = $aborted;
		if($aborted == 1)
		    $BlackP['result'] = "A";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
		writeLog(STAT,$logmess);
            }
            break;
	case 'checkMate':
            if($tmpplayerID['messageFrom'] == 'white'){ 			//white win the game
            	if ( $WhiteP['elo_rate'] == $BlackP['elo_rate'] ){  	//both player have the same skill level
            	    $updownrate = round($WhiteP['constat'] * $expScore);
		    $logmess = "White Set CheckMate | WhiteElo == BlackElo | ";
		}else if( $WhiteP['elo_rate'] < $BlackP['elo_rate'] ){  		//black has a better skill level
                    $updownrate = round($WhiteP['constat'] * $expScore);
		    $logmess = "White Set CheckMate | WhiteElo < BlackElo | ";
		}else{                                                     	//white has a better skill level
                    $updownrate = round($WhiteP['constat'] * (1 - $expScore));
		    $logmess = "White Set CheckMate | WhiteElo > BlackElo | ";
		}

                $WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] + $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] - $updownrate;
		$WhiteP['new_elo_change'] = +$updownrate;
		$BlackP['new_elo_change'] = -$updownrate;
		$WhiteP['result'] = "W";
	    	$BlackP['result'] = "L";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
		writeLog(STAT,$logmess);
           }else{ 								//black win the game
           	if ( $WhiteP['elo_rate'] == $BlackP['elo_rate'] ){			//both player have the same skill level
            	    $updownrate = round($BlackP['constat'] * $expScore);
		    $logmess = "Black Set CheckMate | WhiteElo == BlackElo | ";
		}else if( $WhiteP['elo_rate'] < $BlackP['elo_rate'] ){  		//black has a better skill level
                    $updownrate = round($BlackP['constat'] * (1 - $expScore));
		    $logmess = "Black Set CheckMate | WhiteElo < BlackElo | ";
		}else{                                                     	//white has a better skill level
                    $updownrate = round($BlackP['constat'] * $expScore);
		    $logmess = "Black Set CheckMate | WhiteElo > BlackElo | ";
		}

                $WhiteP['new_elo_rate'] = $WhiteP['elo_rate'] - $updownrate;
  		$BlackP['new_elo_rate'] = $BlackP['elo_rate'] + $updownrate;
		$WhiteP['new_elo_change'] = -$updownrate;
		$BlackP['new_elo_change'] = +$updownrate;
		$WhiteP['result'] = "L";
	    	$BlackP['result'] = "W";
		$logmess .= "WhiteNewElo:".$WhiteP['new_elo_rate']." BlackNewElo:".$BlackP['new_elo_rate']." UpDown:".$updownrate."";
		writeLog(STAT,$logmess);
           }
           break;
    }

    //TODO Calculation of turn frequence in minutes
    $frequence = getTurnFrequence($gameID);
    $WhiteP['turn_freq'] = $frequence['White'];
    $BlackP['turn_freq'] = $frequence['Black'];


    // now update the eleorating table
    $WhiteP['id'] = $WhiteP['id'] + 1;
    $BlackP['id'] = $BlackP['id'] + 1;
    
    $insStr  = "(".$BlackP['id'].",".$BlackP['pID'].",".$gameID.",".$BlackP['new_elo_rate'].",";
    $insStr .= "".$BlackP['new_elo_change'].",".$WhiteP['pID'].",'B','".$BlackP['result']."',";
    $insStr .= "".$BlackP['game_abort'].",".$BlackP['turn_freq'].")";	
    InsStatistic($insStr);
    
    $insStr  = "(".$WhiteP['id'].",".$WhiteP['pID'].",".$gameID.",".$WhiteP['new_elo_rate'].",";
    $insStr .= "".$WhiteP['new_elo_change'].",".$BlackP['pID'].",'W','".$WhiteP['result']."',";
    $insStr .= "".$WhiteP['game_abort'].",".$WhiteP['turn_freq'].")";
    InsStatistic($insStr);

    //delete old entries
    deleteOldEloEntry($BlackP['pID'], $BlackP['id']);
    deleteOldEloEntry($WhiteP['pID'], $WhiteP['id']);
}

############################################################
function getTurnFrequence($gameID){
############################################################
    $freq['White'] = 0;
    $freq['Black'] = 0;
    $freqWhite = 0;
    $freqBlack = 0;
    $dtWhite = 0;
    $dtBlack = 0;
    $cntWhite = 0;
    $cntBlack = 0;
    $startTime = 0;
 
    $logmess = "Enter getTurnFrequence (gameid = ".$gameID.")";
    writeLog(STAT,$logmess);

    $tmpMoveTimes = SelGamesHistory("*","gameID = ".$gameID."","timeOfMove");
    while($tmpMoveTime = GetFetchArray($tmpMoveTimes)){
	if($tmpMoveTime['curColor'] == "white"){
	    $dtWhite = strtotime($tmpMoveTime['timeOfMove']);
	    if($startTime == 0)
		$startTime = $dtWhite;
	    if($startTime != $dtWhite){
		$diffWhite  = intval(date("U",($dtWhite - $startTime)));
		$freqWhite += $diffWhite;
		$cntWhite  += 1;

		$logmess  = "".$cntWhite." White: ".date("1: [d.m.y H:i:s]" ,$startTime)." ";
		$logmess .= "".date("2: [d.m.y H:i:s]" ,$dtWhite)." diff:".$diffWhite."sec";
    		writeLog(STAT,$logmess);

		$startTime = $dtWhite;
	    }
	}else{
	    $dtBlack = strtotime($tmpMoveTime['timeOfMove']);	
	    if($startTime == 0)
		$startTime = $dtBlack;
	    if($startTime != $dtBlack){
		$diffBlack  = intval(date("U",($dtBlack - $startTime)));
		$freqBlack += $diffBlack;
		$cntBlack  += 1;

		$logmess  = "".$cntBlack." Black: ".date("1: [d.m.y H:i:s]" ,$startTime)." ";
		$logmess .= "".date("2: [d.m.y H:i:s]" ,$dtBlack)." diff:".$diffBlack."sec";
    		writeLog(STAT,$logmess);		

		$startTime = $dtBlack;
	    }
	}
    }
    $freq['White'] = round($freqWhite / $cntWhite);
    $freq['Black'] = round($freqBlack / $cntBlack);
    $logmess = "White: ".$freq['White']."sec  Black: ".$freq['Black']."sec ";
    writeLog(STAT,$logmess);
    return $freq;
}

############################################################
function changeStartRate(){
############################################################
    require 'conf/ELOconfig.php';
    $newSetting = "<?PHP\n";
    $newSetting .= "$" . "CFG_ELO_MAX_DB_LINES = ".$CFG_ELO_MAX_DB_LINES.";\n";
    $newSetting .= "$" . "CFG_ELO_RELIAB_LINES = ".$CFG_ELO_RELIAB_LINES.";\n";
    $newSetting .= "$" . "CFG_ELO_MIN_TURN_ELO = ".$CFG_ELO_MIN_TURN_ELO.";\n";
    $newSetting .= "$" . "CFG_ELO_SHOW_ACTIVE_ONLY = ".$CFG_ELO_SHOW_ACTIVE_ONLY.";\n";
    $newSetting .= "//TO CHANGE THE STARTING ELO RATE, MODIFY THIS VARIABLE\n";
    $newSetting .= "//BEFOR YOU CHANGE IT, BACKUP THE user_statistic TABLE\n";
    $newSetting .= "$" . "CFG_ELO_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    if ( $CFG_ELO_OLD_START_RATE == -1){ //initinal start
	$newSetting .= "//DON'T TOUCH THIS VARIABLE ########\n";
	$newSetting .= "$" . "CFG_ELO_OLD_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    }else if( $CFG_ELO_OLD_START_RATE != $CFG_ELO_START_RATE ){  //correct DB
	$eloDiff = $CFG_ELO_START_RATE - $CFG_ELO_OLD_START_RATE;
	$tmpRates = SelStatistic();
        while($thisRate = GetFetchArray($tmpRates)){
	    $newrate = $thisRate['elo_rate'] + $eloDiff;
	    $setStr = "elo_rate = ".$newrate."";
	    $wheStr = "user_id = ".$thisRate['user_id']." AND id = ".$thisRate['id']."";
	    $wheStr .= " AND game_id = ".$thisRate['game_id']."";
	    UpdStatistic($setStr,$wheStr);
	}
	$newSetting .= "//DON'T TOUCH THIS VARIABLE ########\n";
	$newSetting .= "$" . "CFG_ELO_OLD_START_RATE = ".$CFG_ELO_START_RATE.";\n";
    }else
	return;
    
    $newSetting .= "?>";
    $configfile = "conf/ELOconfig.php";
    writefile($configfile,$newSetting,0);
}

############################################################
function deleteOldEloEntry($pID, $lastGameNo){
############################################################
    require 'conf/ELOconfig.php';
    $olderThenNo = $lastGameNo - $CFG_ELO_MAX_DB_LINES + 1;
    if ( $olderThenNo > 0 )
	DelStatistic("user_id = ".$pID." AND id < ".$olderThenNo."");
}

############################################################
function checkGoodGame($gameID){
############################################################
    //return 0=badgame, 1=goodgame
    require 'conf/ELOconfig.php';   
	
    $tmpNumMoves = SelGamesHistory("*","gameID = ".$gameID."");
    $numMoves = GetNumRows($tmpNumMoves);
    if($numMoves < $CFG_ELO_MIN_TURN_ELO){// it's not valid for ELO calculation
	return 0;
    }else{//valid game, so calc ELO for this game
	return 1;
    }
}

############################################################
function checkEndedGame($gameID){
############################################################
    require 'conf/ELOconfig.php';

    //first check for normal game end
    $tmpGames = SelGames("*","gameID = ".$gameID." AND gameMessage = ''");
    if (GetNumRows($tmpGames) == 0)
	return;
    else{// found an aborted game
	//check how many turns has been done
	$tmpNumMoves = SelGamesHistory("*","gameID = ".$gameID."");
    	$numMoves = GetNumRows($tmpNumMoves);

	$thisGame = GetFetchArray($tmpGames);
	/* based on number of moves, output current color's turn */
	if (($numMoves % 2) == 0){
	    $tmpCurMove = "white";
	    $pID 	= $thisGame['whitePlayer'];
	    $color	= "W";
	    $oppID	= $thisGame['blackPlayer'];
	}else{
	    $tmpCurMove = "black";
	    $pID	= $thisGame['blackPlayer'];
	    $color	= "B";
	    $oppID	= $thisGame['whitePlayer'];
	}


	if($numMoves < $CFG_ELO_MIN_TURN_ELO){
	    // game aborted, but it's not valid for ELO calculation, mark only the player who abort this game
	    markAbortPlayer($pID,$oppID,$color,$gameID);

	    //write log
	    $logmess = "UID:".$pID." has aborted the gameID:".$gameID.", ELO was NOT calculated!";
	    writeLog(EVENT,$logmess);
	    return;
	}else{//valid game aborted, so calc ELO for this game
	    //set gamemessage to resign, message from the player how had to do the next move
	    $setStr = "gameMessage = 'playerResigned', messageFrom = '".$tmpCurMove."'";
	    $wheStr = "gameID = ".$gameID."";
	    UpdGames($setStr,$wheStr);

	    // now we can calculate the ELO-rate for this game
	    calcEloRating($gameID, 1);

	    //write log
	    $logmess = "UID:".$pID." has aborted the gameID:".$gameID.", ELO was calculated!";
	    writeLog(EVENT,$logmess);
	    
	    // clear chat for the ended game
	    delUserMsgByGameId($gameID);
	}
    }
}

############################################################
function markAbortPlayer($pID,$oppID,$color,$gameID){
############################################################
    require 'conf/ELOconfig.php';
    //get old elorating info
    $Player = array();
    $tmpElorating = SelStatistic("*","user_id = ".$pID."","id DESC");
    $rows = GetNumRows($tmpElorating);
    if ($rows == 0){
  	$stats['new_elo_rate'] = $CFG_ELO_START_RATE;
  	$stats['id'] 		= 1;
    }else{
  	$tmpElorating = GetFetchArray($tmpElorating);
  	$stats['new_elo_rate']	= $tmpElorating['elo_rate'];
  	$stats['id'] 		= $tmpElorating['id'] + 1;
    }
    $stats['game_abort'] = 1;

    $insStr = "(".$stats['id'].",".$pID.",".$gameID.",".$Player['new_elo_rate'].",0,".$oppID.",'".$color."','A',1,0)";
    InsStatistic($insStr);

    deleteOldEloEntry($pID, $Player['id']);
}


?>
