<?PHP
	
session_start();

/* load settings */
include_once('conf/config.php');
include_once('conf/ELOconfig.php');

/* load external functions */
include_once('lib/chessutils.php');
include_once('lib/chessconstants.php');
include_once('lib/chessdb.php');
include_once('lib/utils.php');
include_once('lib/dbwrapper.php');
include_once('lib/dbutils.php');
include_once('lib/mail.php');
include_once('lib/loginout.php');

############################################################
function inviteHandle(){
############################################################
switch($_POST['ToDo']){
    case 'ResponseToInvite':
	if ($_POST['response'] == 'accepted'){
	    /* update game data */
	    $setStr = "gameMessage = '', messageFrom = ''";
	    $wheStr = "gameID = ".$_POST['gameID'];
	    UpdGames($setStr, $wheStr);

	    /* setup new board */
	    $_SESSION['gameID'] = $_POST['gameID'];
	    createNewGame($_POST['gameID']);
	    saveGame();
	    
	    //write log
	    $logmess = "Response To Invite accepted. gameID: ".$_SESSION['gameID'];
	    writeLog(EVENT,$logmess);
	}else{
	    $setStr = "gameMessage = 'inviteDeclined', messageFrom = '".$_POST['messageFrom']."'";
	    $wheStr = "gameID = ".$_POST['gameID'];
	    UpdGames($setStr,$wheStr);

	    //write log
	    $logmess = "Response To Invite rejected. gameID: ".$_SESSION['gameID'];
	    writeLog(EVENT,$logmess);
	}
	break;

    case 'WithdrawRequest':
	/* get opponent's player ID */
	$tmpOpponentID = SelGames("whitePlayer","gameID = ".$_POST['gameID']."");
	if (GetNumRows($tmpOpponentID) > 0){
	    $tmpID = GetFetchArray($tmpOpponentID);
	    $opponentID = $tmpID['whitePlayer'];

	    if ($opponentID == $_SESSION['playerID']){
		$tmpOpponentID = SelGames("blackPlayer","gameID = ".$_POST['gameID']."");
		$tmpID = GetFetchArray($tmpOpponentID);
		$opponentID = $tmpID['blackPlayer'];
	    }

	    DelGames("gameID = ".$_POST['gameID']."");

	    /* if email notification is activated... */
	    if ($GLOBALS[CFG_USEEMAILNOTIFICATION]){
		$tmpMail = getUserMail($opponentID);
		if($tmpMail['mailnotify'] == 1)
		    webchessMail('withdrawal', $tmpMail['email'], '', $_SESSION['nick']);
	    }
	}
	break;
    }
}

############################################################
function getOppNick($blackID, $whiteID, $thisPlayerID){
############################################################
    $tmpOpp = array();
    if ($whiteID == $thisPlayerID){
	$tmpOpponent = SelUser("login_name","id = ".$blackID."");
	$tmpOpp['id'] = $blackID;
    }else{
	$tmpOpponent = SelUser("login_name","id = ".$whiteID."");
	$tmpOpp['id'] = $whiteID;
    }
    $opponent = GetFetchArray($tmpOpponent);
    $tmpOpp['nick'] = $opponent['login_name'];
    return $tmpOpp;
}

############################################################
function dispColor($whiteID, $thisPlayerID){
############################################################
    if ($whiteID == $thisPlayerID){
	echo ("<td><input class='inmove_white2' type='text' size='10' value='".$_SESSION['TXT']['White']."'></td>");
	$tmpColor = "white";
    }else{
	echo ("<td><input class='inmove_black2' type='text' size='10' value='".$_SESSION['TXT']['Black']."'></td>");
	$tmpColor = "black";
    }
    return $tmpColor;
}

############################################################
function dispMsgIcon($whiteID, $msgForW, $msgForB){
############################################################
    echo ("<td align='center'>");
    if ($whiteID == $_SESSION['playerID']){
	if (($msgForW & 1) == 1)
	    echo ("<img src='template/".$_SESSION['pref_theme']."/images/msg.gif' width='30' height='30' border='0'>");
	if (($msgForW & 2) == 2)
	    echo ("<img src='template/".$_SESSION['pref_theme']."/images/quest.gif' width='30' height='23' border='0'>");
    }else{
	if (($msgForB & 1) == 1)
	    echo ("<img src='template/".$_SESSION['pref_theme']."/images/msg.gif' width='30' height='30' border='0'>");
	if (($msgForB & 2) == 2)
	    echo ("<img src='template/".$_SESSION['pref_theme']."/images/quest.gif' width='30' height='23' border='0'>");
    }
    echo ("</td>\n");
}


############################################################
function dispJSMainMenu() {
############################################################
    echo "<script type='text/javascript'>\n";
    echo " function sendResponse(responseType, messageFrom, gameID){\n";
    echo "  document.responseToInvite.response.value = responseType;\n";
    echo "  document.responseToInvite.messageFrom.value = messageFrom;\n";
    echo "  document.responseToInvite.gameID.value = gameID;\n";
    echo "  document.responseToInvite.submit();\n";
    echo " }\n";
    echo " function loadGame(gameID){\n";
    echo "  if (document.existingGames.rdoShare[0].checked)\n";
    echo "   document.existingGames.action = \"opponentspassword.php\";\n";
    echo "  document.existingGames.gameID.value = gameID;\n";
    echo "  document.existingGames.submit();\n";
    echo " }\n";
    echo " function withdrawRequest(gameID){\n";
    echo "  document.withdrawRequestForm.gameID.value = gameID;\n";
    echo "  document.withdrawRequestForm.submit();\n";
    echo " }\n";
    echo " function loadEndedGame(gameID){\n";
    echo "  document.endedGames.gameID.value = gameID;\n";
    echo "  document.endedGames.submit();\n";
    echo " }\n";
    echo "</script>\n";
}

############################################################
function dispCurInvitations() {
############################################################
    /* if game is marked playerInvited and the invite is from the current player */
    $wheStr  = "(gameMessage = 'playerInvited'";
    $wheStr .= " AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'white')";
    $wheStr .= " OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'black'))";
    $wheStr .= ") OR (gameMessage = 'inviteDeclined'";
    $wheStr .= " AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'black')";
    $wheStr .= " OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'white')))";
    $ordStr  = "dateCreated";
	    	
    $tmpGames = SelGames("*",$wheStr,$ordStr);
    if (GetNumRows($tmpGames) != 0){
    	echo "<form name='withdrawRequestForm' action='mainmenu.php' method='post'>\n";
    	echo "<table class ='tabbord1' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='4'>".$_SESSION['TXT']['CurrInvite']."</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Oppnent']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['YourColor']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Status']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['WithdrawReq']."</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = GetFetchArray($tmpGames)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");

	    /* get opponent's nick */
	    $tmpOpp = getOppNick($tmpGame['blackPlayer'], $tmpGame['whitePlayer'], $_SESSION['playerID']);

	    dispUserInfoLink($tmpOpp['id'], $tmpOpp['nick']);

	    /* Your Color */
	    dispColor($tmpGame['whitePlayer'], $_SESSION['playerID']);

	    /* Status */
	    if ($tmpGame['gameMessage'] == 'playerInvited')
	    	echo ("<td>".$_SESSION['TXT']['ResponsePen']."</td>");
	    else if ($tmpGame['gameMessage'] == 'inviteDeclined')
	    	echo ("<td>".$_SESSION['TXT']['InviteDec']."</td>");

	    /* Withdraw Request */
	    echo ("<td align='center'>");
	    echo ("<input class='button3' type='button' value='".$_SESSION['TXT']['BtnWithdraw']."' onclick='withdrawRequest(".$tmpGame['gameID'].")'>");
	    echo("</td></tr>\n");
	    $tmpcount ++;
    	}
        echo "</table>\n";
        echo "<input type='hidden' name='gameID' value=''>\n";
        echo "<input type='hidden' name='ToDo' value='WithdrawRequest'>\n";
        echo "</form>\n";    
        echo "<br>\n";
    }
}

############################################################
function dispResInvitations() {
############################################################
    $wheStr  = "gameMessage = 'playerInvited'";
    $wheStr .= " AND ((whitePlayer = ".$_SESSION['playerID']." AND messageFrom = 'black')";
    $wheStr .= " OR (blackPlayer = ".$_SESSION['playerID']." AND messageFrom = 'white'))";
    $ordStr  = "dateCreated";

    $tmpGames = SelGames("*",$wheStr,$ordStr);

    if (GetNumRows($tmpGames) != 0){
    	echo "<form name='responseToInvite' action='mainmenu.php' method='post'>\n";
    	echo "<table class ='tabbord1' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='3'>".$_SESSION['TXT']['RespondInv']."</th></tr>\n";
    	echo " <tr>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Oppnent']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['YourColor']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Response']."</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = GetFetchArray($tmpGames)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");

	    /* get opponent's nick */
	    $tmpOpp = getOppNick($tmpGame['blackPlayer'], $tmpGame['whitePlayer'], $_SESSION['playerID']);

	    dispUserInfoLink($tmpOpp['id'], $tmpOpp['nick']);

	    /* Your Color */
	    $tmpFrom = dispColor($tmpGame['whitePlayer'], $_SESSION['playerID']);

	    /* Response */
	    echo ("<td align='center'>");
	    echo ("<input class='button3' type='button' value='".$_SESSION['TXT']['BtnAccept']."' onclick=\"sendResponse('accepted', '".$tmpFrom."', ".$tmpGame['gameID'].")\">");
	    echo ("<input class='button3' type='button' value='".$_SESSION['TXT']['BtnDecline']."' onclick=\"sendResponse('declined', '".$tmpFrom."', ".$tmpGame['gameID'].")\">");

	    echo("</td></tr>\n");
	    $tmpcount ++;
    	}
        echo "</table>\n";
        echo "<input type='hidden' name='response' value=''>\n";
        echo "<input type='hidden' name='messageFrom' value=''>\n";
        echo "<input type='hidden' name='gameID' value=''>\n";
        echo "<input type='hidden' name='ToDo' value='ResponseToInvite'>\n";
        echo "</form>\n";
        echo "<br>\n";
    }
}

############################################################
function dispExistGames() {
############################################################
    $gamearray = array();
    $wheStr  = "gameMessage = '' AND (whitePlayer = ".$_SESSION['playerID']."";
    $wheStr .= " OR blackPlayer = ".$_SESSION['playerID'].")";
    $ordStr  = "dateCreated";
    $tmpGames = SelGames("*",$wheStr,$ordStr);
    if (GetNumRows($tmpGames) != 0){
    	echo "<form name='existingGames' action='chess.php' method='post'>\n";
    	echo "<table class ='tabbord1' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='7'>".$_SESSION['TXT']['ContGame']."</th></tr>\n";
    	echo " <tr>\n";
	echo "  <th class='th_std' width='40px'>".$_SESSION['TXT']['Game']."</th>\n";
	echo "  <th class='th_std' width='60px'>".$_SESSION['TXT']['Msg']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Oppnent']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['YourColor']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['CurTurn']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['StartDate']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['LastMove']."</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = GetFetchArray($tmpGames)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	    	echo("<tr class='tr_std_l'>");

	    dispGameLoadLink($tmpGame['gameID'], 1);
	    
	    /* New Msg */
	    dispMsgIcon($tmpGame['whitePlayer'], $tmpGame['msgforW'], $tmpGame['msgforB']);

	    /* get opponent's nick */
	    $tmpOpp = getOppNick($tmpGame['blackPlayer'], $tmpGame['whitePlayer'], $_SESSION['playerID']);

	    dispUserInfoLink($tmpOpp['id'], $tmpOpp['nick']);

	    $gamearray[$tmpGame['gameID']] = $tmpOpp['nick'];

	    /* Your Color */
	    $tmpColor = dispColor($tmpGame['whitePlayer'], $_SESSION['playerID']);

	    /* Current Turn */
	    /* get number of moves from history */
	    $tmpNumMoves = SelGamesHistory("*","gameID = ".$tmpGame['gameID']."");
	    $numMoves = GetNumRows($tmpNumMoves);
	    /* based on number of moves, output current color's turn */
	    if (($numMoves % 2) == 0)
	    	$tmpCurMove = "white";
	    else
	    	$tmpCurMove = "black";

	    if ($tmpCurMove == $tmpColor)
	        echo("<td>".$_SESSION['TXT']['YourTurn']."</td>");
	    else
	    	echo("<td>".$_SESSION['TXT']['OppTurn']."</td>");

	    /* Start Date */
	    echo ("<td>".$tmpGame['dateCreated']."</td>");

	    /* Last Move */
	    echo ("<td>".$tmpGame['lastMove']."</td>\n");
	    echo ("</tr>");		
	    $tmpcount ++;
    	}

    	/* share PC */
	if($tmpcount%2)
           echo("<tr class='tr_std'>");
        else
	   echo("<tr class='tr_std_l'>");
	echo ("<td colspan='4'>".$_SESSION['TXT']['UseSamePc']."</td>");
    	echo ("<td><input type='radio' name='rdoShare' value='yes'> ".$_SESSION['TXT']['Yes']."</td>");
    	echo ("<td><input type='radio' name='rdoShare' value='no' checked> ".$_SESSION['TXT']['No']."</td>\n");
	echo ("<td></td></tr>");
    	echo "</table>\n";
    	echo "<input type='hidden' name='gameID' value=''>\n";
    	echo "<input type='hidden' name='sharePC' value='no'>\n";
    	echo "</form>\n";
    	echo "<br>\n";
    }
    $_SESSION['yourgames'] = $gamearray;
}

############################################################
function dispEndedGames() {
############################################################
    $wheStr  = "(gameMessage <> '' AND gameMessage <> 'playerInvited' AND gameMessage <> 'inviteDeclined')";
    $wheStr .= " AND (whitePlayer = ".$_SESSION['playerID']." OR blackPlayer = ".$_SESSION['playerID'].")";
    $ordStr  = "lastMove DESC";
    $tmpGames = SelGames("*",$wheStr,$ordStr);
    if (GetNumRows($tmpGames) != 0){
    	echo "<form name='endedGames' action='chess.php' method='post'>\n";
    	echo "<table class ='tabbord1' width='80%'>\n";
    	echo " <tr><th class='th_std' colspan='7'>".$_SESSION['TXT']['EndedGames']."</th></tr>\n";
    	echo " <tr>\n";
	echo "  <th class='th_std' width='40px'>".$_SESSION['TXT']['Game']."</th>\n";
	echo "  <th class='th_std' width='40px'>".$_SESSION['TXT']['Msg']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Oppnent']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['YourColor']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['Status']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['StartDate']."</th>\n";
    	echo "  <th class='th_std'>".$_SESSION['TXT']['LastMove']."</th>\n";
    	echo " </tr>\n";
	$tmpcount = 1;
    	while($tmpGame = GetFetchArray($tmpGames, MYSQL_ASSOC)){
	    /* Opponent */
	    if($tmpcount%2)
           	echo("<tr class='tr_std'>");
            else
	  	echo("<tr class='tr_std_l'>");

	    dispGameLoadLink($tmpGame['gameID']);

	    /* New Msg */
	    dispMsgIcon($tmpGame['whitePlayer'], $tmpGame['msgforW'], $tmpGame['msgforB']);

	    /* get opponent's nick */
	    $tmpOpp = getOppNick($tmpGame['blackPlayer'], $tmpGame['whitePlayer'], $_SESSION['playerID']);

	    dispUserInfoLink($tmpOpp['id'], $tmpOpp['nick']);
	    
	    /* Your Color */
	    dispColor($tmpGame['whitePlayer'], $_SESSION['playerID']);

	    /* Status */
	    dispEndGameMsg($tmpGame['gameMessage'], $tmpGame['messageFrom']);

	    /* Start Date */
	    echo ("<td>".$tmpGame['dateCreated']."</td>");

	    /* Last Move */
	    echo ("<td>".$tmpGame['lastMove']."</td></tr>\n");
	    $tmpcount ++;
    	}
    	echo "</table>\n";
    	echo "<input type='hidden' name='gameID' value=''>\n";
    	echo "<input type='hidden' name='sharePC' value='no'>\n";
    	echo "</form>\n";
    	echo "<br>\n";
    }
}

############################################################
function dispMainMenuPage() {
############################################################
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head>\n";
    echo "<meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n";
    echo " <title>WebChessNG - ".$_SESSION['TXT']['TitleMainMenu']."</title>\n";
    echo " <link rel='stylesheet' type='text/css' href='template/".$_SESSION['pref_theme']."/webchess.css'>\n";
    dispJSMainMenu();
    echo "</head><body><br>\n";
    echo " <center>\n";
    $pagetitle = $_SESSION['TXT']['TitleMainMenu'];
    displayMenu($pagetitle);
    dispCurInvitations();
    dispResInvitations();
    dispExistGames();
    dispEndedGames();
    dispfootNote();
    echo " </center>\n";
    echo "</body></html>\n";
}

loginout();

CheckSession();

/* check session status */
//include_once('lib/sessioncheck.php');
if ($_SESSION['usrgrpid'] != 1)
    dbmaintance();

inviteHandle();
/* set default playing mode to different PCs (as opposed to both players sharing a PC) */
$_SESSION['isSharedPC'] = false;

dispMainMenuPage();

?>
